import { DispatcherClient as PbDispatcherClient, AssignedAction } from '../../protoc/dispatcher';
import { ClientConfig } from '../hatchet-client/client-config';
import { Logger } from '../../util/logger';
import { DispatcherClient } from './dispatcher-client';
export interface Action {
    tenantId: string;
    jobId: string;
    jobName: string;
    jobRunId: string;
    stepId: string;
    stepRunId: string;
    actionId: string;
    actionType: number;
    actionPayload: string;
    workflowRunId: string;
    getGroupKeyRunId: string;
}
export declare class ActionListener {
    config: ClientConfig;
    client: PbDispatcherClient;
    workerId: string;
    logger: Logger;
    lastConnectionAttempt: number;
    retries: number;
    retryInterval: number;
    retryCount: number;
    constructor(client: DispatcherClient, workerId: string, retryInterval?: number, retryCount?: number);
    actions: () => AsyncGenerator<Action, void, unknown>;
    incrementRetries(): Promise<void>;
    getListenClient(): Promise<AsyncIterable<AssignedAction>>;
    unregister(): Promise<import("../../protoc/dispatcher").WorkerUnsubscribeResponse>;
}
