import { Channel, ClientFactory } from 'nice-grpc';
import { DispatcherClient as PbDispatcherClient, StepActionEvent, GroupKeyActionEvent } from '../../protoc/dispatcher';
import { ClientConfig } from '../hatchet-client/client-config';
import { Logger } from '../../util/logger';
import { ActionListener } from './action-listener';
interface GetActionListenerOptions {
    workerName: string;
    services: string[];
    actions: string[];
    maxRuns?: number;
}
export declare class DispatcherClient {
    config: ClientConfig;
    client: PbDispatcherClient;
    logger: Logger;
    constructor(config: ClientConfig, channel: Channel, factory: ClientFactory);
    getActionListener(options: GetActionListenerOptions): Promise<ActionListener>;
    sendStepActionEvent(in_: StepActionEvent): Promise<import("../../protoc/dispatcher").ActionEventResponse>;
    sendGroupKeyActionEvent(in_: GroupKeyActionEvent): Promise<import("../../protoc/dispatcher").ActionEventResponse>;
}
export {};
