"use strict";
/* eslint-disable */
/* tslint:disable */
/*
 * ---------------------------------------------------------------
 * ## THIS FILE WAS GENERATED VIA SWAGGER-TYPESCRIPT-API        ##
 * ##                                                           ##
 * ## AUTHOR: acacode                                           ##
 * ## SOURCE: https://github.com/acacode/swagger-typescript-api ##
 * ---------------------------------------------------------------
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.Api = void 0;
const http_client_1 = require("./http-client");
class Api extends http_client_1.HttpClient {
    constructor() {
        super(...arguments);
        /**
         * @description Gets metadata for the Hatchet instance
         *
         * @tags Metadata
         * @name MetadataGet
         * @summary Get metadata
         * @request GET:/api/v1/meta
         */
        this.metadataGet = (params = {}) => this.request(Object.assign({ path: `/api/v1/meta`, method: 'GET', format: 'json' }, params));
        /**
         * @description List all integrations
         *
         * @tags Metadata
         * @name MetadataListIntegrations
         * @summary List integrations
         * @request GET:/api/v1/meta/integrations
         * @secure
         */
        this.metadataListIntegrations = (params = {}) => this.request(Object.assign({ path: `/api/v1/meta/integrations`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Logs in a user.
         *
         * @tags User
         * @name UserUpdateLogin
         * @summary Login user
         * @request POST:/api/v1/users/login
         */
        this.userUpdateLogin = (data, params = {}) => this.request(Object.assign({ path: `/api/v1/users/login`, method: 'POST', body: data, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Starts the OAuth flow
         *
         * @tags User
         * @name UserUpdateGoogleOauthStart
         * @summary Start OAuth flow
         * @request GET:/api/v1/users/google/start
         */
        this.userUpdateGoogleOauthStart = (params = {}) => this.request(Object.assign({ path: `/api/v1/users/google/start`, method: 'GET' }, params));
        /**
         * @description Completes the OAuth flow
         *
         * @tags User
         * @name UserUpdateGoogleOauthCallback
         * @summary Complete OAuth flow
         * @request GET:/api/v1/users/google/callback
         */
        this.userUpdateGoogleOauthCallback = (params = {}) => this.request(Object.assign({ path: `/api/v1/users/google/callback`, method: 'GET' }, params));
        /**
         * @description Starts the OAuth flow
         *
         * @tags User
         * @name UserUpdateGithubOauthStart
         * @summary Start OAuth flow
         * @request GET:/api/v1/users/github/start
         * @secure
         */
        this.userUpdateGithubOauthStart = (params = {}) => this.request(Object.assign({ path: `/api/v1/users/github/start`, method: 'GET', secure: true }, params));
        /**
         * @description Completes the OAuth flow
         *
         * @tags User
         * @name UserUpdateGithubOauthCallback
         * @summary Complete OAuth flow
         * @request GET:/api/v1/users/github/callback
         * @secure
         */
        this.userUpdateGithubOauthCallback = (params = {}) => this.request(Object.assign({ path: `/api/v1/users/github/callback`, method: 'GET', secure: true }, params));
        /**
         * @description Github App global webhook
         *
         * @tags Github
         * @name GithubUpdateGlobalWebhook
         * @summary Github app global webhook
         * @request POST:/api/v1/github/webhook
         */
        this.githubUpdateGlobalWebhook = (params = {}) => this.request(Object.assign({ path: `/api/v1/github/webhook`, method: 'POST' }, params));
        /**
         * @description Github App tenant webhook
         *
         * @tags Github
         * @name GithubUpdateTenantWebhook
         * @summary Github app tenant webhook
         * @request POST:/api/v1/github/webhook/{webhook}
         */
        this.githubUpdateTenantWebhook = (webhook, params = {}) => this.request(Object.assign({ path: `/api/v1/github/webhook/${webhook}`, method: 'POST' }, params));
        /**
         * @description Gets the current user
         *
         * @tags User
         * @name UserGetCurrent
         * @summary Get current user
         * @request GET:/api/v1/users/current
         * @secure
         */
        this.userGetCurrent = (params = {}) => this.request(Object.assign({ path: `/api/v1/users/current`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Registers a user.
         *
         * @tags User
         * @name UserCreate
         * @summary Register user
         * @request POST:/api/v1/users/register
         */
        this.userCreate = (data, params = {}) => this.request(Object.assign({ path: `/api/v1/users/register`, method: 'POST', body: data, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Logs out a user.
         *
         * @tags User
         * @name UserUpdateLogout
         * @summary Logout user
         * @request POST:/api/v1/users/logout
         * @secure
         */
        this.userUpdateLogout = (params = {}) => this.request(Object.assign({ path: `/api/v1/users/logout`, method: 'POST', secure: true, format: 'json' }, params));
        /**
         * @description Lists all tenant memberships for the current user
         *
         * @tags User
         * @name TenantMembershipsList
         * @summary List tenant memberships
         * @request GET:/api/v1/users/memberships
         * @secure
         */
        this.tenantMembershipsList = (params = {}) => this.request(Object.assign({ path: `/api/v1/users/memberships`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Lists all tenant invites for the current user
         *
         * @tags Tenant
         * @name UserListTenantInvites
         * @summary List tenant invites
         * @request GET:/api/v1/users/invites
         * @secure
         */
        this.userListTenantInvites = (params = {}) => this.request(Object.assign({ path: `/api/v1/users/invites`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Accepts a tenant invite
         *
         * @tags Tenant
         * @name TenantInviteAccept
         * @summary Accept tenant invite
         * @request POST:/api/v1/users/invites/accept
         * @secure
         */
        this.tenantInviteAccept = (data, params = {}) => this.request(Object.assign({ path: `/api/v1/users/invites/accept`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json }, params));
        /**
         * @description Rejects a tenant invite
         *
         * @tags Tenant
         * @name TenantInviteReject
         * @summary Reject tenant invite
         * @request POST:/api/v1/users/invites/reject
         * @secure
         */
        this.tenantInviteReject = (data, params = {}) => this.request(Object.assign({ path: `/api/v1/users/invites/reject`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json }, params));
        /**
         * @description Creates a new tenant
         *
         * @tags Tenant
         * @name TenantCreate
         * @summary Create tenant
         * @request POST:/api/v1/tenants
         * @secure
         */
        this.tenantCreate = (data, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Creates a new tenant invite
         *
         * @tags Tenant
         * @name TenantInviteCreate
         * @summary Create tenant invite
         * @request POST:/api/v1/tenants/{tenant}/invites
         * @secure
         */
        this.tenantInviteCreate = (tenant, data, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/invites`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Gets a list of tenant invites
         *
         * @tags Tenant
         * @name TenantInviteList
         * @summary List tenant invites
         * @request GET:/api/v1/tenants/{tenant}/invites
         * @secure
         */
        this.tenantInviteList = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/invites`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Updates a tenant invite
         *
         * @name TenantInviteUpdate
         * @summary Update invite
         * @request PATCH:/api/v1/tenants/{tenant}/invites/{tenant-invite}
         * @secure
         */
        this.tenantInviteUpdate = (tenant, tenantInvite, data, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/invites/${tenantInvite}`, method: 'PATCH', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Deletes a tenant invite
         *
         * @name TenantInviteDelete
         * @summary Delete invite
         * @request DELETE:/api/v1/tenants/{tenant}/invites/{tenant-invite}
         * @secure
         */
        this.tenantInviteDelete = (tenant, tenantInvite, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/invites/${tenantInvite}`, method: 'DELETE', secure: true, format: 'json' }, params));
        /**
         * @description Create an API token for a tenant
         *
         * @tags API Token
         * @name ApiTokenCreate
         * @summary Create API Token
         * @request POST:/api/v1/tenants/{tenant}/api-tokens
         * @secure
         */
        this.apiTokenCreate = (tenant, data, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/api-tokens`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description List API tokens for a tenant
         *
         * @tags API Token
         * @name ApiTokenList
         * @summary List API Tokens
         * @request GET:/api/v1/tenants/{tenant}/api-tokens
         * @secure
         */
        this.apiTokenList = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/api-tokens`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Revoke an API token for a tenant
         *
         * @tags API Token
         * @name ApiTokenUpdateRevoke
         * @summary Revoke API Token
         * @request POST:/api/v1/api-tokens/{api-token}
         * @secure
         */
        this.apiTokenUpdateRevoke = (apiToken, params = {}) => this.request(Object.assign({ path: `/api/v1/api-tokens/${apiToken}`, method: 'POST', secure: true }, params));
        /**
         * @description Lists all events for a tenant.
         *
         * @tags Event
         * @name EventList
         * @summary List events
         * @request GET:/api/v1/tenants/{tenant}/events
         * @secure
         */
        this.eventList = (tenant, query, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/events`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Replays a list of events.
         *
         * @tags Event
         * @name EventUpdateReplay
         * @summary Replay events
         * @request POST:/api/v1/tenants/{tenant}/events/replay
         * @secure
         */
        this.eventUpdateReplay = (tenant, data, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/events/replay`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Gets a list of tenant members
         *
         * @tags Tenant
         * @name TenantMemberList
         * @summary List tenant members
         * @request GET:/api/v1/tenants/{tenant}/members
         * @secure
         */
        this.tenantMemberList = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/members`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get the data for an event.
         *
         * @tags Event
         * @name EventDataGet
         * @summary Get event data
         * @request GET:/api/v1/events/{event}/data
         * @secure
         */
        this.eventDataGet = (event, params = {}) => this.request(Object.assign({ path: `/api/v1/events/${event}/data`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Lists all event keys for a tenant.
         *
         * @tags Event
         * @name EventKeyList
         * @summary List event keys
         * @request GET:/api/v1/tenants/{tenant}/events/keys
         * @secure
         */
        this.eventKeyList = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/events/keys`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get all workflows for a tenant
         *
         * @tags Workflow
         * @name WorkflowList
         * @summary Get workflows
         * @request GET:/api/v1/tenants/{tenant}/workflows
         * @secure
         */
        this.workflowList = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/workflows`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get a workflow for a tenant
         *
         * @tags Workflow
         * @name WorkflowGet
         * @summary Get workflow
         * @request GET:/api/v1/workflows/{workflow}
         * @secure
         */
        this.workflowGet = (workflow, params = {}) => this.request(Object.assign({ path: `/api/v1/workflows/${workflow}`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get a workflow version for a tenant
         *
         * @tags Workflow
         * @name WorkflowVersionGet
         * @summary Get workflow version
         * @request GET:/api/v1/workflows/{workflow}/versions
         * @secure
         */
        this.workflowVersionGet = (workflow, query, params = {}) => this.request(Object.assign({ path: `/api/v1/workflows/${workflow}/versions`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Trigger a new workflow run for a tenant
         *
         * @tags Workflow Run
         * @name WorkflowRunCreate
         * @summary Trigger workflow run
         * @request POST:/api/v1/workflows/{workflow}/trigger
         * @secure
         */
        this.workflowRunCreate = (workflow, data, query, params = {}) => this.request(Object.assign({ path: `/api/v1/workflows/${workflow}/trigger`, method: 'POST', query: query, body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Get a workflow version definition for a tenant
         *
         * @tags Workflow
         * @name WorkflowVersionGetDefinition
         * @summary Get workflow version definition
         * @request GET:/api/v1/workflows/{workflow}/versions/definition
         * @secure
         */
        this.workflowVersionGetDefinition = (workflow, query, params = {}) => this.request(Object.assign({ path: `/api/v1/workflows/${workflow}/versions/definition`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Link a github repository to a workflow
         *
         * @tags Workflow
         * @name WorkflowUpdateLinkGithub
         * @summary Link github repository
         * @request POST:/api/v1/workflows/{workflow}/link-github
         * @secure
         */
        this.workflowUpdateLinkGithub = (workflow, data, params = {}) => this.request(Object.assign({ path: `/api/v1/workflows/${workflow}/link-github`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Create a pull request for a workflow
         *
         * @tags Workflow
         * @name StepRunUpdateCreatePr
         * @summary Create pull request
         * @request POST:/api/v1/step-runs/{step-run}/create-pr
         * @secure
         */
        this.stepRunUpdateCreatePr = (stepRun, data, params = {}) => this.request(Object.assign({ path: `/api/v1/step-runs/${stepRun}/create-pr`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Get the diff for a step run between the most recent run and the first run.
         *
         * @tags Workflow
         * @name StepRunGetDiff
         * @summary Get diff
         * @request GET:/api/v1/step-runs/{step-run}/diff
         * @secure
         */
        this.stepRunGetDiff = (stepRun, params = {}) => this.request(Object.assign({ path: `/api/v1/step-runs/${stepRun}/diff`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get all workflow runs for a tenant
         *
         * @tags Workflow
         * @name WorkflowRunList
         * @summary Get workflow runs
         * @request GET:/api/v1/tenants/{tenant}/workflows/runs
         * @secure
         */
        this.workflowRunList = (tenant, query, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/workflows/runs`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Get a workflow run for a tenant
         *
         * @tags Workflow
         * @name WorkflowRunGet
         * @summary Get workflow run
         * @request GET:/api/v1/tenants/{tenant}/workflow-runs/{workflow-run}
         * @secure
         */
        this.workflowRunGet = (tenant, workflowRun, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/workflow-runs/${workflowRun}`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description List all pull requests for a workflow run
         *
         * @tags Workflow
         * @name WorkflowRunListPullRequests
         * @summary List pull requests
         * @request GET:/api/v1/tenants/{tenant}/workflow-runs/{workflow-run}/prs
         * @secure
         */
        this.workflowRunListPullRequests = (tenant, workflowRun, query, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/workflow-runs/${workflowRun}/prs`, method: 'GET', query: query, secure: true, format: 'json' }, params));
        /**
         * @description Get a step run by id
         *
         * @tags Step Run
         * @name StepRunGet
         * @summary Get step run
         * @request GET:/api/v1/tenants/{tenant}/step-runs/{step-run}
         * @secure
         */
        this.stepRunGet = (tenant, stepRun, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/step-runs/${stepRun}`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Reruns a step run
         *
         * @tags Step Run
         * @name StepRunUpdateRerun
         * @summary Rerun step run
         * @request POST:/api/v1/tenants/{tenant}/step-runs/{step-run}/rerun
         * @secure
         */
        this.stepRunUpdateRerun = (tenant, stepRun, data, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/step-runs/${stepRun}/rerun`, method: 'POST', body: data, secure: true, type: http_client_1.ContentType.Json, format: 'json' }, params));
        /**
         * @description Get all workers for a tenant
         *
         * @tags Worker
         * @name WorkerList
         * @summary Get workers
         * @request GET:/api/v1/tenants/{tenant}/worker
         * @secure
         */
        this.workerList = (tenant, params = {}) => this.request(Object.assign({ path: `/api/v1/tenants/${tenant}/worker`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description Get a worker
         *
         * @tags Worker
         * @name WorkerGet
         * @summary Get worker
         * @request GET:/api/v1/workers/{worker}
         * @secure
         */
        this.workerGet = (worker, params = {}) => this.request(Object.assign({ path: `/api/v1/workers/${worker}`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description List Github App installations
         *
         * @tags Github
         * @name GithubAppListInstallations
         * @summary List Github App installations
         * @request GET:/api/v1/github-app/installations
         * @secure
         */
        this.githubAppListInstallations = (params = {}) => this.request(Object.assign({ path: `/api/v1/github-app/installations`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description List Github App repositories
         *
         * @tags Github
         * @name GithubAppListRepos
         * @summary List Github App repositories
         * @request GET:/api/v1/github-app/installations/{gh-installation}/repos
         * @secure
         */
        this.githubAppListRepos = (ghInstallation, params = {}) => this.request(Object.assign({ path: `/api/v1/github-app/installations/${ghInstallation}/repos`, method: 'GET', secure: true, format: 'json' }, params));
        /**
         * @description List Github App branches
         *
         * @tags Github
         * @name GithubAppListBranches
         * @summary List Github App branches
         * @request GET:/api/v1/github-app/installations/{gh-installation}/repos/{gh-repo-owner}/{gh-repo-name}/branches
         * @secure
         */
        this.githubAppListBranches = (ghInstallation, ghRepoOwner, ghRepoName, params = {}) => this.request(Object.assign({ path: `/api/v1/github-app/installations/${ghInstallation}/repos/${ghRepoOwner}/${ghRepoName}/branches`, method: 'GET', secure: true, format: 'json' }, params));
    }
}
exports.Api = Api;
