"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.retrier = void 0;
const sleep_1 = __importDefault(require("./sleep"));
const DEFAULT_RETRY_INTERVAL = 5;
const DEFAULT_RETRY_COUNT = 5;
function retrier(fn, logger, retries = DEFAULT_RETRY_COUNT, interval = DEFAULT_RETRY_INTERVAL) {
    return __awaiter(this, void 0, void 0, function* () {
        let lastError;
        // eslint-disable-next-line no-plusplus
        for (let i = 0; i < retries; i++) {
            try {
                return yield fn();
            }
            catch (e) {
                lastError = e;
                logger.error(`Error: ${e.message}`);
                yield (0, sleep_1.default)(interval * 1000);
            }
        }
        throw lastError;
    });
}
exports.retrier = retrier;
