"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateWorkflowSchema = exports.HatchetTimeoutSchema = exports.WorkflowConcurrency = exports.ConcurrencyLimitStrategy = void 0;
const z = __importStar(require("zod"));
const step_1 = require("./step");
const workflows_1 = require("./protoc/workflows");
const CronConfigSchema = z.object({
    cron: z.string(),
    event: z.undefined(),
});
const EventConfigSchema = z.object({
    cron: z.undefined(),
    event: z.string(),
});
const OnConfigSchema = z.union([CronConfigSchema, EventConfigSchema]);
const StepsSchema = z.array(step_1.CreateStepSchema);
exports.ConcurrencyLimitStrategy = workflows_1.ConcurrencyLimitStrategy;
exports.WorkflowConcurrency = z.object({
    name: z.string(),
    maxRuns: z.number().optional(),
    limitStrategy: z.nativeEnum(exports.ConcurrencyLimitStrategy).optional(),
});
exports.HatchetTimeoutSchema = z.string();
exports.CreateWorkflowSchema = z.object({
    id: z.string(),
    description: z.string(),
    version: z.string().optional(),
    scheduleTimeout: z.string().optional(),
    timeout: exports.HatchetTimeoutSchema.optional(),
    on: OnConfigSchema,
    steps: StepsSchema,
});
